//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property  indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 Lime//LimeGreen
#property indicator_color3 PaleVioletRed
#property indicator_color4 Red//HotPink
#property indicator_color5 Black//Silver
#property indicator_color6 Black//Silver
#property indicator_color7 Black//Silver
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern int LwmaPeriod = 56;
extern int LwmaPrice  = PRICE_CLOSE;
extern int EmaPeriod  = 10;

//
//
//
//
//

double slope[];
double ema1[];
double ema2[];
double slopeuu[];
double slopeud[];
double slopedu[];
double slopedd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{      
   IndicatorDigits(8);    
   SetIndexBuffer(0,slopeud); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,slopeuu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,slopedd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,slopedu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,slope);
   SetIndexBuffer(5,ema1);
   SetIndexBuffer(6,ema2);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);   

   //
   //
   //
   //
   //
   
      double alpha = 2.0/(1.0+EmaPeriod);
      for (int i=limit; i>=0; i--)
      {
         slope[i] = (iMA(NULL,0,LwmaPeriod+1,0,MODE_LWMA,LwmaPrice,i)-calcWhatever(LwmaPeriod,i));
         if (slope[i]>0)
               ema1[i] = ema1[i+1]+alpha*(slope[i]-ema1[i+1]);
         else  ema1[i] = ema1[i+1];
         if (slope[i]<0)
               ema2[i] = ema2[i+1]+alpha*(slope[i]-ema2[i+1]);
         else  ema2[i] = ema2[i+1];
         
         //
         //
         //
         //
         //
         
         slopeuu[i] = EMPTY_VALUE;
         slopeud[i] = EMPTY_VALUE;
         slopedd[i] = EMPTY_VALUE;
         slopedu[i] = EMPTY_VALUE;
            if (slope[i]>ema1[i]) { slopeuu[i] = slope[i]; continue; }
            if (slope[i]>0)       { slopeud[i] = slope[i]; continue; }
            if (slope[i]<ema2[i]) { slopedu[i] = slope[i]; continue; }
            if (slope[i]<0)       { slopedd[i] = slope[i]; continue; }
      }
      return( 0 );
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double calcWhatever( int period, int i)
{
   double Sum  = (period+1)*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i+1)+period*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i);
   double Sumw = (period+1)+period;
   int j,k;

      //
      //
      //
      //
      //
      
      for (j=1, k=period; j <= period; j++,k-- )
      {
         Sum  += k*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i+j+1);
         Sumw += k;
      }

   return( Sum / Sumw );
}

